#include <stdio.h>
#include <pcap.h>

FILE *fd_data, *fd_headers;

class Session {
private:
		u_int SIP[4];
		u_int DIP[4];
		u_int SPort;
		u_int DPort;
public:
		Session(const u_char *pkt_data, int IPlen) {
				SIP[0] = pkt_data[26]; SIP[1] = pkt_data[27]; SIP[2] = pkt_data[28]; SIP[3] = pkt_data[29];
				DIP[0] = pkt_data[30]; DIP[1] = pkt_data[31]; DIP[2] = pkt_data[32]; DIP[3] = pkt_data[33];
				SPort = (pkt_data[14+IPlen] * 256) + pkt_data[15+IPlen];
				DPort = (pkt_data[16+IPlen] * 256) + pkt_data[17+IPlen];
		}

		Session(char *str1, char *str2) {
				sscanf(str1, "%u.%u.%u.%u:%u", &SIP[0], &SIP[1], &SIP[2], &SIP[3], &SPort);
				sscanf(str2, "%u.%u.%u.%u:%u", &DIP[0], &DIP[1], &DIP[2], &DIP[3], &DPort);
		}

		int compare(Session other) {
				if((SIP[0] == other.SIP[0]) && (SIP[1] == other.SIP[1]) && (SIP[2] == other.SIP[2]) && (SIP[3] == other.SIP[3]))
						if((DIP[0] == other.DIP[0]) && (DIP[1] == other.DIP[1]) && (DIP[2] == other.DIP[2]) && (DIP[3] == other.DIP[3]))
								if((SPort == other.SPort) && (DPort == other.DPort))
										return 1;
				if((SIP[0] == other.DIP[0]) && (SIP[1] == other.DIP[1]) && (SIP[2] == other.DIP[2]) && (SIP[3] == other.DIP[3]))
						if((DIP[0] == other.SIP[0]) && (DIP[1] == other.SIP[1]) && (DIP[2] == other.SIP[2]) && (DIP[3] == other.SIP[3]))
								if((SPort == other.DPort) && (DPort == other.SPort))
										return -1;
				return 0;
		}

		void print() {
				fprintf(fd_headers, "Source: %u.%u.%u.%u:%u\n", SIP[0], SIP[1], SIP[2], SIP[3], SPort);
				fprintf(fd_headers, "Destination: %u.%u.%u.%u:%u\n", DIP[0], DIP[1], DIP[2], DIP[3], DPort);
		}
};

Session *wanted = NULL;
void dispatcher_handler(u_char *, const struct pcap_pkthdr *, const u_char *);

int main(int argc, char **argv) {
		if(argc != 4) {
				printf("Pouziti: %s file SourceIP:SourcePort DestinationIP:DestinationPort\n", argv[0]);
				printf("Priklad: %s file 192.168.0.1:4567 147.32.80.1:80\n", argv[0]);
				exit(1);
		}

		fd_data = fopen("data", "w");
		fd_headers = fopen("headers", "w");

		wanted = new Session(argv[2], argv[3]);

		pcap_t *fp;
		char errbuf[PCAP_ERRBUF_SIZE];

		/* Open the capture file */
		if ((fp = pcap_open_offline(argv[1], errbuf)) == NULL) {
				fprintf(stderr,"\nUnable to open the file %s.\n", argv[1]);
				return -1;
		}

		/* read and dispatch packets until EOF is reached */
		pcap_loop(fp, 0, dispatcher_handler, NULL);

		pcap_close(fp);
		return 0;
}

enum Phase {closed, PSYN, SYNACK, opened, PFIN, FINACK, FINACK2};

void dispatcher_handler(u_char *temp1, const struct pcap_pkthdr *header, const u_char *pkt_data) {
		static u_int frame = 0;
		static u_short WindowSize = 0;
		static u_int AvaitAckS = 0;
		static u_int AvaitAckD = 0;
//		static u_int RelSeqS = 0;
//		static u_int RelSeqD = 0;
		static Phase phase = closed;

		frame++;

		if((header->len > 14) && (pkt_data[12] == 8) && (pkt_data[13] == 0)) {
				u_char IPlen = (pkt_data[14] & 0x0f) * 4;
				u_char IPver = pkt_data[14] >> 4;
				if(IPver == 4) {
//						int ToS = pkt_data[15];
						u_short Length = (pkt_data[16] * 256) + pkt_data[17];
						u_short ID = (pkt_data[18] * 256) + pkt_data[19];
						boolean DF = (pkt_data[20] & 0x40) > 0;
						boolean MF = (pkt_data[20] & 0x20) > 0;
						u_short Offset = ((pkt_data[20] & 0x1F) * 256) + pkt_data[21];
						u_char TTL = pkt_data[22];
						u_char Protokol = pkt_data[23];

						if(Protokol == 6) {
								Session current(pkt_data, IPlen);
								int direction = wanted->compare(current);
								if(direction != 0) {
										u_int SequenceN = (pkt_data[18+IPlen] << 32) + (pkt_data[19+IPlen] << 16) + (pkt_data[20+IPlen] << 8) + pkt_data[21+IPlen];
										u_int AcknowledgeN = (pkt_data[22+IPlen] << 32) + (pkt_data[23+IPlen] << 16) + (pkt_data[24+IPlen] << 8) + pkt_data[25+IPlen];
										u_char TCPlen = (pkt_data[26+IPlen] >> 4) * 4;
										boolean URG = (pkt_data[27+IPlen] & 0x20) > 0;
										boolean ACK = (pkt_data[27+IPlen] & 0x10) > 0;
										boolean PSH = (pkt_data[27+IPlen] & 0x08) > 0;
										boolean RST = (pkt_data[27+IPlen] & 0x04) > 0;
										boolean SYN = (pkt_data[27+IPlen] & 0x02) > 0;
										boolean FIN = (pkt_data[27+IPlen] & 0x01) > 0;
										u_short Window = (pkt_data[28+IPlen] * 256) + pkt_data[29+IPlen];
										u_short Urgent = (pkt_data[32+IPlen] * 256) + pkt_data[33+IPlen];

										if(direction == -1) {
												fprintf(fd_headers, "<<< "); //Ack expected: %08x, Ack received: %08x\n", AvaitAckS, AcknowledgeN);
												if(SYN) {
														AvaitAckS = SequenceN + 2;
												} else if(AvaitAckS != (AcknowledgeN)) {
														fprintf(fd_headers, "Paket ztracen\n");
														fprintf(fd_headers, "Wanted: 0x%08x, Get: 0x%08x\n", AvaitAckS, AcknowledgeN);
												}
												AvaitAckD = SequenceN + Length - IPlen - TCPlen;
										}
										else {
												fprintf(fd_headers, ">>> "); //Ack expected: %08x, Ack received: %08x\n", AvaitAckD, AcknowledgeN);
												if(SYN) {
														AvaitAckD = SequenceN + 2;
												} else	if(AvaitAckD != (AcknowledgeN)) {
														fprintf(fd_headers, "Paket ztracen\n");
														fprintf(fd_headers, "Wanted: 0x%08x, Get: 0x%08x\n", AvaitAckD, AcknowledgeN);
												}
												AvaitAckS = SequenceN + Length - IPlen - TCPlen;
										}

										time_t timer = header->ts.tv_sec;
										tm *time = localtime(&timer);
										fprintf(fd_headers, "Frame nr. %d; Time: %d:%02d:%02d.%ld; Length: %ld / %d\n", frame, time->tm_hour, time->tm_min, time->tm_sec, header->ts.tv_usec, header->len, Length - IPlen - TCPlen);

										if(MF) fprintf(fd_headers, "Fragmentace\n");
										
										fprintf(fd_headers, "URG: %d, ACK: %d, PSH: %d, RST: %d, SYN: %d, FIN: %d\n", URG, ACK, PSH, RST, SYN, FIN);
										
										if(((phase == closed) || (phase == FINACK)) && SYN && !ACK) {
												fprintf(fd_headers, "Start relace\n");
												phase = PSYN;
												AvaitAckS = SequenceN + 1;
										} else if((phase == PSYN) && SYN && ACK) {
												fprintf(fd_headers, "Prijmuti relace\n");
												phase = SYNACK;
												AvaitAckD = SequenceN + 1;
										} else if((phase == SYNACK) && ACK) {
												fprintf(fd_headers, "Relace ustanovena\n");
												phase = opened;
										}
										
										if(((phase == opened) || (phase == PFIN)) && FIN) {
												fprintf(fd_headers, "Ukoncovani relace\n");
												phase = PFIN;
												if(direction > 0)	AvaitAckS++;
												else AvaitAckD++;
										} else if((phase == FINACK) && FIN) {
												fprintf(fd_headers, "Ukoncovani relace\n");
												phase = FINACK2;
												if(direction > 0)	AvaitAckS++;
												else AvaitAckD++;
										} else if((phase == FINACK2) && ACK) {
												fprintf(fd_headers, "Relace ukoncena\n");
												phase = closed;
										} else if((phase == PFIN) && ACK) {
												fprintf(fd_headers, "Relace ukoncena\n");
												phase = FINACK;
										}

										if(Window != WindowSize) {
												fprintf(fd_headers, "Nova velikost okna: %d\n", Window);
												WindowSize = Window;
										}

										int dataBegin = (14 + IPlen + TCPlen);
										if(dataBegin < 14 + Length) {
											fprintf(fd_data, (direction == -1) ? "<<< " : ">>> ");

											for (u_int i = dataBegin; i < 14 + Length; i++) {
//												if(((i-dataBegin) % LINE_LEN) == 0) fprintf(fd_headers, "\n");
												fprintf(fd_data, "%c", pkt_data[i]);
											}
										}
										fprintf(fd_headers, "\n");
								}
						}
				}
		}
}
